unit CRegistryStatusUnit;
//Basis-Klasse fr alle anderen Klassen!

interface
uses Windows,SysUtils,StdCtrls,Dialogs;

type CRegistryStatus=class(TObject)
 constructor Create;virtual;abstract;
 constructor CreateBool(chk:TCheckBox);virtual;abstract;
 destructor Destroy;virtual;
public
 procedure Change;virtual; //es hat sich was gendert !

protected
 function KeyExists(Path:String):boolean; //gibt aus ob Key existiert..
 function DeleteKey(Path:String):boolean; //lscht einen Key

 function CreateKeyLI(Path:String;Value:longint):boolean;
 function CreateKeyString(Path:String;Value:String):boolean;
  //Falls Path nur Pfad ist, wird Value von Standard editiert!
 function QueryKeyString(Path:String):string;
 function QueryKeyLI(Path:String):Longint;

 procedure RestartWindows(Restart:Boolean); //Mu windows neu gestart werden
 procedure ShowSetError;
protected
 //ein paar Standard-Variablen
 strTMPKey:string; //TEMP KeyPath (meistens fr BOOL-Einstellungen)
 cChk:TCheckBox; //fr Bool Einstellungen
protected //nur proteced, falls eine Kindclass die mal brauchen wrde
 function OpenKey(Path:String):HKEY;
 function CloseKey(key:HKEY):Boolean;
private
 function GetKeyStart(Path:String):HKEY;
 function GetKeyPath(Path:string):string;
 function GetKeyValue(Path:string):string;
 function CreateKey(Path:String;Value:pointer;VLength:Longint;Typ:Integer):boolean; //erstellt einen neuen Key;
end;

var
 bRestartShouldTakePlace:Boolean; //Globale Variable

implementation
destructor CRegistryStatus.Destroy;
begin end;

procedure CRegistryStatus.Change;
begin end;

procedure CRegistryStatus.RestartWindows(Restart:Boolean);
begin
 if (bRestartShouldTakePlace=False) and (Restart=True) then
  bRestartShouldTakePlace:=True;
end;

function CRegistryStatus.OpenKey(Path:String):HKEY;
//ffnet den strKeyPath
var key:HKEY;
    rt:longint;
    dwSome:DWord;
begin
 dwSome:=0;
 rt:=RegCreateKeyEx(GetKeyStart(Path),PChar(GetKeyPath(Path)),0,
                    '',REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
                    NIL,key,PDWord(dwSome));

 if rt<>ERROR_SUCCESS then
  OpenKey:=-32768
 else
  OpenKey:=key;
end;

function CRegistryStatus.CloseKey(key:HKEY):Boolean;
var rt:Longint;
begin
 rt:=RegCloseKey(key);

 if rt<>ERROR_SUCCESS then
  CloseKey:=FALSE
 else
  CloseKey:=TRUE;
end;

function CRegistryStatus.CreateKeyString(Path:String;Value:String):boolean;
begin
 CreateKeyString:=CreateKey(Path,PChar(Value),Length(Value),1);
end;

function CRegistryStatus.CreateKeyLI(Path:String;Value:Longint):boolean;
begin
 CreateKeyLI:=CreateKey(Path,@Value,SizeOf(Value),2);
end;

function CRegistryStatus.CreateKey(Path:String;Value:pointer;VLength:Longint;Typ:Integer):boolean;
var
 rt:Longint;
 key:HKEY;
 dwTyp:DWord;
begin
 if Typ=1 then //Typ 1 ist String (0teminiert)
  dwTyp:=REG_SZ
 else //Typ 2 ist Binary...
  dwTyp:=REG_BINARY;

 key:=OpenKey(Path);

 if key=-32768 then //Fehler-Wert von OpenKey
  CreateKey:=FALSE
 else begin
  rt:=RegSetValueEx(key,PChar(GetKeyValue(Path)),0,dwTyp,Value,VLength);

  if rt<>ERROR_SUCCESS then
   CreateKey:=FALSE
  else
   CreateKey:=TRUE;

  CloseKey(key);
 end;
end;

function CRegistryStatus.DeleteKey(Path:String):boolean;
var
 rt:Longint;
 key:HKEY;
begin
 key:=OpenKey(Path);

 if key=-32768 then
  DeleteKey:=FALSE
 else begin
  if Copy(Path,Length(Path),1)='\' then begin
   //ShowMessage('DEBUG: Lsche KEY!!!! '+Path);
   rt:=RegDeleteKey(key,PChar(GetKeyValue(Path)))
  end
  else
   rt:=RegDeleteValue(key,PChar(GetKeyValue(Path)));

  if rt=ERROR_SUCCESS then
   DeleteKey:=TRUE
  else
   DeleteKey:=FALSE;

  CloseKey(Key);
 end;
end;

function CRegistryStatus.QueryKeyString(Path:String):string;
var
 rt:Longint;
 key:HKEY;
 pCh:PChar;
 dwSize:DWord;
begin
 key:=OpenKey(Path);

 if key=-32768 then
  QueryKeyString:=''
 else begin
  pCh:=StrAlloc(1025);
  dwSize:=1024;
  rt:=RegQueryValueEx(key,PChar(GetKeyValue(Path)),NIL,NIL,pointer(pCH),@dwSize);
  if rt<>ERROR_SUCCESS then
   QueryKeyString:=''
  else
   QueryKeyString:=String(pCH);

  StrDispose(pCH);
  CloseKey(key);
 end;
end;

function CRegistryStatus.QueryKeyLI(Path:String):Longint;
var
 key:HKEY;
 dwSize:DWord;
 rt:longint;
 i:longint;
begin
 key:=OpenKey(Path);
 i:=1234;
 if key=-32768 then
  QueryKeyLI:=0
 else begin
  dwSize:=sizeof(Longint);
  rt:=RegQueryValueEx(key,PChar(GetKeyValue(Path)),NIL,NIL,@i,@dwSize);
  if rt<>ERROR_SUCCESS then
   QueryKeyLI:=0
  else
   QueryKeyLI:=i;

  CloseKey(key);
 end;
end;

function CRegistryStatus.KeyExists(Path:String):boolean;
var
 rt:Longint;
 key:HKEY;
begin
 rt:=RegOpenKeyEx(GetKeyStart(Path),PChar(GetKeyPath(Path)),0,
                  KEY_ALL_ACCESS,key);
 //Open mu selber laufen, da wir keinen Key ERZEUGEN mchten =>RegCreateKeyEx..
 if rt<>ERROR_SUCCESS then
  KeyExists:=FALSE
 else begin //alles okay..
  rt:=RegQueryValueEx(key,PChar(GetKeyValue(Path)),NIL,NIL,NIL,NIL);
  if rt<>ERROR_SUCCESS then //yo, gefunden !
   KeyExists:=FALSE
  else
   KeyExists:=TRUE;

  CloseKey(key);
 end;
end;

function CRegistryStatus.GetKeyStart(Path:String):HKEY;
//ermittelt aus dem Krzel am Anfang von Path den richtigen HKEY
var
 rt:HKEY;
 strTMP:string[4];
begin
 rt:=0;
 strTMP:=Copy(Path,1,4); //die 4 Buchstaben ermitteln

 if strTMP='HKCU' then rt:=HKEY_CURRENT_USER  //HKCU
 else if strTMP='HKCR' then rt:=HKEY_CLASSES_ROOT  //HKCR
      else if strTMP='HKLM' then rt:=HKEY_LOCAL_MACHINE //HKLM
           else if strTMP='HKUS' then rt:=HKEY_USERS   //HKUS
                else ShowMessage('GetKeyStart says: BAD Argument of '+strTMP);

 GetKeyStart:=rt;
end;

function CRegistryStatus.GetKeyPath(Path:string):string;
var strTMP:string;
    strPath:string;
    i:integer;
begin
 StrPath:='';
 strTMP:=Copy(Path,6,Length(Path));

 i:=Pos('\',strTMP);
 while i<>0 do begin
  strPath:=strPath+Copy(strTMP,1,i);
  strTMP:=Copy(strTMP,i+1,length(strTMP)-i);
  i:=Pos('\',strTMP);
 end;

 if Copy(StrPath,length(StrPath),1)='\' then //wenn "\" am Ende => abschneiden
  strPath:=Copy(strPath,1,length(strPath)-1);

 GetKeyPath:=strPath;
end;

function CRegistryStatus.GetKeyValue(Path:string):string;
var
 strTMP:string;
 iVBegin:integer; //wo fngt das Ding an
begin
 strTMP:=GetKeyPath(Path); //Pfad ermitteln

 if (length(strTMP)=0) or (length(Path)-5<0) then
  GetKeyValue:=''
 else begin
  iVBegin:=length(strTMP)+2+5;//+2 fr absend '\';+5 fr fehlendes HKxx
  strTMP:=Copy(Path,iVBegin,(Length(Path)+1)-iVBegin);
 end;
 GetKeyValue:=strTMP;
end;

procedure CRegistryStatus.ShowSetError;
var
 strTMP:string;
begin
 strTMP:='Die gewnschte nderung konnte nicht ausgefhrt werden. ';
 strTMP:=strTMP+'Mglicherweise bearbeitet ein anderes Programm die Registry. ';
 MessageDlg(strTMP,mtError,[mbOK],0);
end;

end.

