unit ClassDOSSYSOptionsUnit;
//Kapselt die Einstellungen der MSDos.sys
//absolut grauenhaft in Bezug auf OOP aber die Sache war
//mir zu gefhrlich: MSDos.sys kaputt => Windows kaputt !

interface
uses SysUtils,Dialogs,IniFiles,StdCtrls,Windows;

type ClassDOSSYSOptions=class(TObject)
 constructor Create(chk_ShowSplash:TCheckBox;
                    chk_BootKeys:TCheckBox;
                    chk_ShowBootMenu:TCheckBox;
                    chk_BootGui:TCheckBox;
                    chk_LoadDBLSpace:TCheckBox;
                    chk_LoadDRVSpace:TCheckBox;
                    chk_LoadTop:TCheckBox;
                    chk_SafeModeWarning:TCheckBox;
                    edi_BootKeysDelay:TEdit;
                    sta_BootKeysDelay:TLabel);
 destructor Destroy;
public
 procedure ChangeShowSplash;
 procedure ChangeShowBootMenu;
 procedure ChangeEnableBootKeys;
 procedure ChangeBootGUI;
 procedure ChangeLoadDRVSpace;
 procedure ChangeLoadDBLSpace;
 procedure ChangeLoadTop;
 procedure ChangeSafeModeWarning;
 procedure ChangeBootKeysDelay;
protected
 procedure InitValues; //liest die Values aus und fllt die Variabeln
 procedure WriteValues;
 function GetFilePath:string;
 procedure ProtectDOSSys;
 procedure UnprotectDOSSys;
 procedure InitShowSplash;
 procedure InitBootKeys;
 procedure InitShowBootMenu;
 procedure InitBootGUI;
 procedure InitLoadDBLSpace;
 procedure InitLoadDRVSpace;
 procedure InitLoadTop;
 procedure InitSafeModeWarning;
 procedure InitBootKeysDelay;
protected
 strDOSSysFilePath:String;
 bBootKey:Boolean;
 bShowBootMenu:Boolean;
 bBootGUI:Boolean;
 bLoadDBLSpace:Boolean;
 bLoadDRVSpace:Boolean;
 bLoadTop:Boolean;
 bShowSplash:Boolean;
 bSafeModeWarning:Boolean;
 iBootKeysDelay:Integer;

 //Pointer auf Controls
 cShowSplash:TCheckBox;
 cBootKeys:TCheckBox;
 cShowBootMenu:TCheckBox;
 cBootGUI:TCheckBox;
 cLoadDBLSpace:TCheckBox;
 cLoadDRVSpace:TCheckBox;
 cLoadTOP:TCheckBox;
 cSafeModeWarning:TCheckBox;
 cBootKeysDelay:TEdit;
 cBootKeysDelay_sta:TLabel;
end;

implementation
//*.cpp
constructor ClassDOSSYSOptions.Create(chk_ShowSplash:TCheckBox;
                    chk_BootKeys:TCheckBox;
                    chk_ShowBootMenu:TCheckBox;
                    chk_BootGui:TCheckBox;
                    chk_LoadDBLSpace:TCheckBox;
                    chk_LoadDRVSpace:TCheckBox;
                    chk_LoadTop:TCheckBox;
                    chk_SafeModeWarning:TCheckBox;
                    edi_BootKeysDelay:TEdit;
                    sta_BootKeysDelay:TLabel);
begin
 cShowSplash:=chk_ShowSplash;
 cBootKeys:=chk_BootKeys;
 cShowBootMenu:=chk_ShowBootMenu;
 cBootGUI:=chk_BootGUI;
 cLoadDBLSpace:=chk_LoadDBLSpace;
 cLoadDRVSpace:=chk_LoadDRVSpace;
 cLoadTOP:=chk_LoadTop;
 cSafeModeWarning:=chk_SafeModeWarning;
 cBootKeysDelay:=edi_BootKeysDelay;
 cBootKeysDelay_sta:=sta_BootKeysDelay;

 GetFilePath;
// strDOSSysFilePath:='';
 UnprotectDOSSys; //sicher ist sicher...

 //Init der Werte..
 InitValues;

 //Init der Controls...
 InitShowSplash;
 InitBootKeys;
 InitShowBootMenu;
 InitBootGUI;
 InitLoadDBLSpace;
 InitLoadDRVSpace;
 InitLoadTop;
 InitSafeModeWarning;
 InitBootKeysDelay;
end;

destructor ClassDOSSYSOptions.Destroy;
begin
 UnprotectDosSys;
 WriteValues;
 ProtectDosSys;
end;

procedure ClassDOSSYSOptions.ProtectDOSSys;
begin
 SetFileAttributes(PChar(strDOSSysFilePAth),FILE_ATTRIBUTE_HIDDEN);
end;

procedure ClassDOSSYSOptions.UnprotectDOSSys;
begin
 SetFileAttributes(PChar(strDOSSysFilePath),FILE_ATTRIBUTE_ARCHIVE);
end;

procedure ClassDOSSYSOptions.WriteValues;
var
 x:TIniFile;
 s:string;
begin
 if strDOSSysFilePath<>'' then begin
  x:=TIniFile.Create(strDOSSysFilePath);
  s:='Options';
  try
   x.WriteBool(s,'BootKeys',bBootKey);
   x.WriteBool(s,'BootMenu',bShowBootMenu);
   x.WriteBool(s,'BootGUI',bBootGUI);
   x.WriteBool(s,'BootWarn',bSafeModeWarning);
   x.WriteBool(s,'DBLSpace',bLoadDBLSpace);
   x.WriteBool(s,'DRVSpace',bLoadDRVSpace);
   x.WriteBool(s,'LoadTop',bLoadTop);
   x.WriteBool(s,'Logo',bShowSplash);
   x.WriteInteger(s,'BootDelay',iBootKeysDelay);
  except
   MessageDlg('Fehler beim Schreiben des MSDOS.SYS! Bitte versuchen Sie es spter nochmal!',
              mtError,[mbOK],0);
  end;
  x.Free;
 end;
end;

procedure ClassDOSSYSOptions.InitShowSplash;
begin
 if strDOSSysFilePath<>'' then
  cShowSplash.Checked:=bShowSplash
 else
  cShowSplash.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitBootKeys;
begin
 if strDOSSysFilePath<>'' then
  cBootKeys.Checked:=bBootKey
 else
  cBootKeys.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitShowBootMenu;
begin
 if strDOSSysFilePath<>'' then
  cShowBootMenu.Checked:=bShowBootMenu
 else
  cShowBootMenu.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitBootGUI;
begin
 if strDOSSysFilePath<>'' then
  cBootGUI.Checked:=bBootGUI
 else
  cBootGUI.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitLoadDBLSpace;
begin
 if strDOSSysFilePath<>'' then
  cLoadDBLSpace.Checked:=bLoadDBLSpace
 else
  cLoadDBLSpace.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitLoadDRVSpace;
begin
 if strDOSSysFilePath<>'' then
  cLoadDRVSpace.Checked:=bLoadDRVSpace
 else
  cLoadDRVSpace.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitLoadTop;
begin
 if strDOSSysFilePath<>'' then
  cLoadTop.Checked:=bLoadTop
 else
  cLoadTop.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitSafeModeWarning;
begin
 if strDOSSysFilePath<>'' then
  cSafeModeWarning.Checked:=bSafeModeWarning
 else
  cSafeModeWarning.Enabled:=False;
end;

procedure ClassDOSSYSOptions.InitBootKeysDelay;
var s:string;
begin
 if strDOSSysFilePath<>'' then begin
  Str(iBootKeysDelay,S);
  cBootKeysDelay.Text:=s;
 end
 else begin
  cBootKeysDelay.Enabled:=False;
  cBootKeysDelay_sta.Enabled:=False;
 end;
end;


function ClassDOSSYSOptions.GetFilePath:string;
var
 x:TIniFile;
 s:string;
begin
 if FileExists('C:\MSDOS.SYS')=False then
  strDOSSysFilePath:=''
 else begin
  x:=TIniFile.Create('C:\MSDOS.sys');
  s:=x.ReadString('Paths','HostWinBootDrv','');
  x.Free;
  if s='' then
   strDOSSysFilePath:=''
  else begin
   if FileExists(s+':\MSDOS.SYS')=False then
    strDOSSysFilePath:=''
   else begin
    strDOSSysFilePath:=s+':\MSDOS.SYS';
   end;
  end;
 end;
end;

procedure ClassDOSSYSOptions.InitValues;
var
 x:TIniFile;
 s:string;
begin
 //Standard-Init
 bBootKey:=True;
 bShowBootMenu:=False;
 bBootGUI:=True;
 bSafeModeWarning:=True;
 bLoadDBLSpace:=False;
 bLoadDRVSpace:=False;
 bLoadTop:=True;
 bShowSplash:=True;
 iBootKeysDelay:=2;

 s:='Options'; //ich faul...
 x:=TIniFile.Create(strDOSSysFilePath);
 bBootKey:=x.ReadBool(s,'BootKeys',bBootKey);
 bShowBootMenu:=x.ReadBool(s,'BootMenu',bShowBootMenu);
 bBootGUI:=x.ReadBool(s,'BootGUI',bBootGUI);
 bSafeModeWarning:=x.ReadBool(s,'BootWarn',bSafeModeWarning);
 bLoadDBLSpace:=x.ReadBool(s,'DBLSpace',bLoadDBLSpace);
 bLoadDRVSpace:=x.ReadBool(s,'DRVSpace',bLoadDRVSpace);
 bLoadTop:=x.ReadBool(s,'LoadTop',bLoadTop);
 bShowSplash:=x.ReadBool(s,'Logo',bShowSplash);
 iBootKeysDelay:=x.ReadInteger(s,'BootDelay',iBootKeysDelay);
 x.Free;
end;

procedure ClassDOSSYSOptions.ChangeShowSplash;
begin
 bShowSplash:=cShowSplash.Checked;
end;

procedure ClassDOSSYSOptions.ChangeShowBootMenu;
begin
 bShowBootMenu:=cShowBootMenu.Checked;
end;

procedure ClassDOSSYSOptions.ChangeEnableBootKeys;
begin
 bBootKey:=cBootKeys.Checked;
end;

procedure ClassDOSSYSOptions.ChangeBootGUI;
begin
 bBootGUI:=cBootGUI.Checked;
end;

procedure ClassDOSSYSOptions.ChangeLoadDRVSpace;
begin
 bLoadDRVSpace:=cLoadDRVSpace.Checked;
end;

procedure ClassDOSSYSOptions.ChangeLoadDBLSpace;
begin
 bLoadDBLSpace:=cLoadDBLSpace.Checked;
end;

procedure ClassDOSSYSOptions.ChangeLoadTop;
begin
 bLoadTop:=cLoadTOP.Checked;
end;

procedure ClassDOSSYSOptions.ChangeSafeModeWarning;
begin
 bSafeModeWarning:=cSafeModeWarning.Checked;
end;

procedure ClassDOSSYSOptions.ChangeBootKeysDelay;
var s:string;
    i:integer;
begin
 s:=cBootKeysDelay.Text;
 try
  i:=StrToInt(s);
  if (i<0) or (i>99) then
   raise EConvertError.Create('Falsche Zahlen');
  iBootKeysDelay:=i; 
 except
  MessageDlg('Bitte geben Sie einen Wert zwischen 1 und 99 ein.',mtError,[mbOK],0);
  cBootKeysDelay.Text:=IntToStr(iBootKEysDelay);  
 end;
end;
end.
